<?php

declare(strict_types=1);

namespace Dedi\SyliusCustomerReferralPlugin\Domain\Referral\Repository;

use Dedi\SyliusCustomerReferralPlugin\Domain\Referral\Exception\InviteeAlreadyInvitedException;
use Dedi\SyliusCustomerReferralPlugin\Domain\Referral\Model\ReferralModelInterface;

interface ReferralRepositoryInterface
{
    /**
     * @throws InviteeAlreadyInvitedException
     */
    public function save(ReferralModelInterface $referralModel): ReferralModelInterface;

    public function findByInviteeEmail(?string $inviteeEmail): ?ReferralModelInterface;

    public function findByCode(string $code): ?ReferralModelInterface;
}
