<?php

declare(strict_types=1);

namespace Tests\Dedi\SyliusCustomerReferralPlugin\Application\Entity;

use Dedi\SyliusCustomerReferralPlugin\Entity\InviterTrait;
use Dedi\SyliusCustomerReferralPlugin\Entity\InviteeTrait;
use Dedi\SyliusCustomerReferralPlugin\Entity\InviteeInterface;
use Dedi\SyliusCustomerReferralPlugin\Entity\InviterInterface;
use Doctrine\ORM\Mapping as ORM;
use Sylius\Component\Core\Model\ShopUser as BaseShopUser;
use Sylius\Component\Core\Model\ShopUserInterface;

/**
 * @ORM\Entity()
 * @ORM\Table(name="sylius_shop_user")
 */
class ShopUser extends BaseShopUser implements ShopUserInterface, InviterInterface, InviteeInterface
{
    use InviterTrait {
        InviterTrait::__construct as private __inviterConstruct;
    }

    use InviteeTrait;

    public function __construct()
    {
        parent::__construct();

        $this->__inviterConstruct();
    }
}
